
; Created by:   Paul E. Brennick
; Homepage: http://www.pbrennick.com

  .386
  .model flat, stdcall
  option casemap :none                 ; Case sensitive

  include \GeneSys\include\windows.inc
  include \GeneSys\include\user32.inc
  include \GeneSys\include\kernel32.inc
  include \GeneSys\include\gdi32.inc
  include \GeneSys\include\GeneSys.inc
  include \GeneSys\include\comctl32.inc
  include \GeneSys\include\advapi32.inc
  include \GeneSys\INCLUDE\shell32.inc

  includelib  \GeneSys\lib\user32.lib
  includelib  \GeneSys\lib\kernel32.lib
  includelib  \GeneSys\lib\gdi32.lib
  includelib  \GeneSys\lib\GeneSys.lib
  includelib  \GeneSys\lib\comctl32.lib
  includelib  \GeneSys\lib\advapi32.lib
  includelib  \GeneSys\lib\shell32.lib

  include Protect.inc
  include Macros.asm
  include registry.asm
  include Dialogs.asm

CPlApplet PROTO :DWORD, :DWORD, :DWORD, :DWORD

.CODE

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
;--------------------------------------
  .IF reason==DLL_PROCESS_ATTACH

    INVOKE GetModuleHandle, addr nameCPL ; NULL
    mov hInstance, eax

  .ENDIF

  mov  eax,TRUE
  ret
;--------------------------------------
DllEntry Endp


CPlApplet proc hWnd:DWORD, uMsg:DWORD, lParam1:DWORD, lParam2:DWORD
;--------------------------------------
  .IF uMsg == CPL_INIT

  .ELSEIF uMsg == CPL_GETCOUNT

    mov     eax, 1

  .ELSEIF uMsg == CPL_INQUIRE

    push    esi
    mov     esi, lParam2
    assume  esi:ptr CPLINFO
    mov     [esi].lData, 0
    mov     [esi].idIcon, 200
    mov     [esi].idName, 3000
    mov     [esi].idInfo, 3001
    assume  esi: nothing
    pop     esi

  .ELSEIF uMsg == CPL_DBLCLK

; Set up the 1st property sheet

    mov     PropSheet.dwSize, sizeof PROPSHEETPAGE
    m2m     PropSheet.dwFlags, PSP_DEFAULT + PSP_USEICONID
    m2m     PropSheet.hInstance, hInstance
    m2m     PropSheet.pszTemplate, offset mydb1
    mov     PropSheet.pszIcon, 201
    m2m     PropSheet.pfnDlgProc, offset DialogFunc1
    m2m     PropSheet.pszTitle, offset psztitle
    mov     PropSheet.lParam, 0
    mov     PropSheet.pfnCallback, 0

; Set up the 2nd property sheet

    mov     PropSheet[(sizeof PROPSHEETPAGE)].dwSize, sizeof PROPSHEETPAGE
    m2m     PropSheet[(sizeof PROPSHEETPAGE)].dwFlags, PSP_DEFAULT + PSP_USEICONID
    m2m     PropSheet[(sizeof PROPSHEETPAGE)].hInstance, hInstance
    m2m     PropSheet[(sizeof PROPSHEETPAGE)].pszTemplate, offset mydb2
    mov     PropSheet[(sizeof PROPSHEETPAGE)].pszIcon, 202
    m2m     PropSheet[(sizeof PROPSHEETPAGE)].pfnDlgProc, offset DialogFunc2
    m2m     PropSheet[(sizeof PROPSHEETPAGE)].pszTitle, offset psztitle
    mov     PropSheet[(sizeof PROPSHEETPAGE)].lParam, 0
    mov     PropSheet[(sizeof PROPSHEETPAGE)].pfnCallback, 0

; Set up the 3rd property sheet
 
    mov     PropSheet[(sizeof PROPSHEETPAGE)*2].dwSize, sizeof PROPSHEETPAGE
    m2m     PropSheet[(sizeof PROPSHEETPAGE)*2].dwFlags, PSP_DEFAULT + PSP_USEICONID
    m2m     PropSheet[(sizeof PROPSHEETPAGE)*2].hInstance, hInstance
    m2m     PropSheet[(sizeof PROPSHEETPAGE)*2].pszTemplate, offset mydb3
    mov     PropSheet[(sizeof PROPSHEETPAGE)*2].pszIcon, 203
    m2m     PropSheet[(sizeof PROPSHEETPAGE)*2].pfnDlgProc, offset DialogFunc3
    m2m     PropSheet[(sizeof PROPSHEETPAGE)*2].pszTitle, offset psztitle
    mov     PropSheet[(sizeof PROPSHEETPAGE)*2].lParam, 0
    mov     PropSheet[(sizeof PROPSHEETPAGE)*2].pfnCallback, 0

; Create the 3 Pages

    invoke  CreatePropertySheetPage, ADDR PropSheet
    mov     hPs, eax
    invoke  CreatePropertySheetPage, ADDR PropSheet[sizeof PROPSHEETPAGE]
    mov     hPs[4], eax
    invoke  CreatePropertySheetPage, ADDR PropSheet[(sizeof PROPSHEETPAGE)*2]
    mov     hPs[8], eax

; Set up the property sheet header

    mov     PropHdr.dwSize, sizeof PROPSHEETHEADERA
    mov     PropHdr.dwFlags, PSH_DEFAULT
    m2m     PropHdr.hwndParent,NULL     ;hWnd
    m2m     PropHdr.hInstance, hInstance
    mov     PropHdr.pszIcon, 0
    m2m     PropHdr.pszCaption, offset caption
    mov     PropHdr.nPages, 3
    mov     PropHdr.nStartPage, 0
    m2m     PropHdr.phpage, offset hPs
    mov     PropHdr.pfnCallback, 0

; Display the property sheet control

    invoke  PropertySheet, ADDR PropHdr

  .ELSEIF uMsg == CPL_STOP

    return  0

  .ELSEIF uMsg == CPL_EXIT

    return  1

  .ENDIF

  ret
;--------------------------------------
CPlApplet endp

END DllEntry
