
.code

;--------------------------------------;
; Dialogs for ProperSheet              ;
;--------------------------------------;

DialogFunc1 proc uses ebx, hdwnd:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM 
;--------------------------------------
; This dialog processes property sheet 1

  mov     eax, uMsg

  .IF eax==WM_NOTIFY

    mov     ebx, lParam
    mov     eax, NMHDR.code[ebx]

    .IF eax==PSN_SETACTIVE             ; Page gaining focus

      m2m     hPropSheet, NMHDR.hwndFrom[ebx]
      invoke  SetWindowLong, hdwnd, DWL_MSGRESULT, 0
      return  TRUE

    .ELSEIF eax==PSN_APPLY

      mov     REG_TYPE, REG_DWORD
      xor     eax, eax
      mov     eax, 1001
      mov     ebx, 501

looping3:

      push    eax
      push    ebx
      invoke  LoadString, hInstance, eax, addr NameValue, TailNameValue
      invoke  SendDlgItemMessage, hdwnd, ebx, BM_GETCHECK, NULL, NULL
      mov     dword ptr [ValueDD], eax
      invoke  SetRegValue, HKEY_CURRENT_USER, addr Registry1, addr NameValue, REG_TYPE, addr ValueDD, 4
      pop     ebx
      pop     eax
      inc     eax
      inc     ebx
      cmp     eax, 1011
      jne     looping3

    .ELSEIF eax==PSN_KILLACTIVE          ; Page loosing focus

      invoke  SendDlgItemMessage, hdwnd, IDD_CB1, BM_GETCHECK, 0, 0
      mov     cb1, eax
      invoke  SendDlgItemMessage, hdwnd, IDD_CB2, BM_GETCHECK, 0, 0
      mov     cb2, eax
      invoke  SendDlgItemMessage, hdwnd, IDD_CB3, BM_GETCHECK, 0, 0
      mov     cb3, eax
      invoke  SendDlgItemMessage, hdwnd, IDD_CB4, BM_GETCHECK, 0, 0
      mov     cb4, eax
      invoke  SendDlgItemMessage, hdwnd, IDD_CB5, BM_GETCHECK, 0, 0
      mov     cb5, eax
      invoke  SendDlgItemMessage, hdwnd, IDD_CB6, BM_GETCHECK, 0, 0
      mov     cb6, eax
      invoke  SetWindowLong, hdwnd, DWL_MSGRESULT, 0
      return  TRUE

    .ELSEIF eax==PSN_RESET               ; Add your own cancel code here

    .ENDIF

  .ELSEIF eax==WM_COMMAND

    LOWORD  wParam

    .IF eax==IDD_CB2 || eax==IDD_CB3 || eax==IDD_CB4 || eax==IDD_CB5 || eax==IDD_CB6

      invoke  SendMessage, hPropSheet, PSM_CHANGED, hdwnd, 0
      return  TRUE

    .ELSEIF eax==IDD_CB1

      invoke  SendDlgItemMessage, hdwnd, IDD_CB1, BM_GETCHECK, NULL, NULL
      mov     ebx, IDD_CB1
      mov     ecx, eax
      xor     ecx, 1

@@:

      push    ecx
      inc     ebx
      invoke  GetDlgItem, hdwnd, ebx
      pop     ecx
      push    ecx
      invoke  EnableWindow, eax, ecx
      pop     ecx
      cmp     ebx, IDD_CB5
      jne     @B
      invoke  SendMessage, hPropSheet, PSM_CHANGED, hdwnd, 0
      return  TRUE

    .ENDIF
    
  .ELSEIF eax==WM_INITDIALOG           ; Initialise the list box

    mov     REG_TYPE, REG_DWORD
    xor     eax, eax
    mov     eax, 1001
    mov     ebx, 501

looping:

    push    eax
    push    ebx
    invoke  LoadString, hInstance, eax, addr NameValue, TailNameValue
    invoke  GetRegValue, HKEY_CURRENT_USER, addr Registry1, addr NameValue, addr REG_TYPEsz, addr Value, addr TailValue
    push    eax
    invoke  SendDlgItemMessage, hdwnd, ebx, BM_SETCHECK, eax, 0
    pop     eax

    .IF al == 1 && ebx == 501

looping2:

      inc     ebx
      invoke  GetDlgItem, hdwnd, ebx
      invoke  EnableWindow, eax, FALSE
      cmp     ebx, 505
      jne     looping2

    .ENDIF

    pop     ebx
    pop     eax
    inc     eax
    inc     ebx
    cmp     eax, 1011
    jne     looping
    return  TRUE

  .ENDIF

  return FALSE
;--------------------------------------
DialogFunc1 endp


DialogFunc2 proc uses ebx, hdwnd:DWORD, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM 
;--------------------------------------
; This dialog processes property sheet 2

  mov     eax, uMsg

  .IF eax==WM_NOTIFY

    mov     ebx, lParam
    mov     eax, NMHDR.code[ebx]

    .IF eax==PSN_SETACTIVE             ; Page gaining focus

      m2m     hPropSheet, NMHDR.hwndFrom[ebx]
      invoke  SetWindowLong, hdwnd, DWL_MSGRESULT, 0
      return  TRUE

    .ELSEIF eax==PSN_KILLACTIVE        ; Page loosing focus

      invoke  SendDlgItemMessage, hdwnd, IDD_RB1, BM_GETCHECK, 0, 0
      mov     rb1, eax
      invoke  SendDlgItemMessage, hdwnd, IDD_RB2, BM_GETCHECK, 0, 0
      mov     rb2, eax
      invoke  SendDlgItemMessage, hdwnd, IDD_RB3, BM_GETCHECK, 0, 0
      mov     rb3, eax
      invoke  SetWindowLong, hdwnd, DWL_MSGRESULT, 0
      return  TRUE

    .ELSEIF eax==PSN_RESET             ; Add you own cancel code here

    .ENDIF

  .ELSEIF eax==WM_COMMAND

    LOWORD  wParam

    .IF eax==IDD_RB1 || eax==IDD_RB2 || eax== IDD_RB3

      invoke  SendMessage, hPropSheet, PSM_CHANGED, hdwnd, 0
      return  TRUE

    .ELSEIF eax==IDD_TOP

      invoke  SendMessage, hPropSheet, PSM_CHANGED, hdwnd, 0
      invoke  SendDlgItemMessage, hdwnd, IDD_RB2, BM_SETCHECK, 0, 0    ; Clear RB2 & 3
      invoke  SendDlgItemMessage, hdwnd, IDD_RB3, BM_SETCHECK, 0, 0
      invoke  SendDlgItemMessage, hdwnd, IDD_RB1, BM_SETCHECK, 1, 0    ; Set RB1
      return  TRUE

    .ELSEIF eax==IDD_BOTTOM

      invoke  SendMessage, hPropSheet, PSM_CHANGED, hdwnd, 0
      invoke  SendDlgItemMessage, hdwnd, IDD_RB1, BM_SETCHECK, 0, 0    ; Clear RB1 & 2
      invoke  SendDlgItemMessage, hdwnd, IDD_RB2, BM_SETCHECK, 0, 0
      invoke  SendDlgItemMessage, hdwnd, IDD_RB3, BM_SETCHECK, 1, 0    ; Set RB3
      return  TRUE

    .ENDIF

  .ELSEIF eax==WM_INITDIALOG           ; Initialise the list box
        
    invoke  SendDlgItemMessage, hdwnd, IDD_RB1, BM_SETCHECK, rb1, 0    ; 1st set as default
    invoke  SendDlgItemMessage, hdwnd, IDD_RB2, BM_SETCHECK, rb2, 0
    invoke  SendDlgItemMessage, hdwnd, IDD_RB3, BM_SETCHECK, rb3, 0
    return  TRUE

  .ENDIF

  return FALSE
;--------------------------------------
DialogFunc2 endp


DialogFunc3 proc uses ebx, hdwnd:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM 
;--------------------------------------
;   This dialog processes property page 3

  LOCAL   strr[80]:BYTE

  mov     eax, uMsg

  .IF eax==WM_NOTIFY

    mov     ebx, lParam
    mov     eax, NMHDR.code[ebx]

    .IF eax==PSN_SETACTIVE             ; Page gaining focus

      m2m     hPropSheet, NMHDR.hwndFrom[ebx]
      m2m     index, lb1sel
      invoke  SetWindowLong, hdwnd, DWL_MSGRESULT, 0
      return  TRUE

    .ELSEIF eax==PSN_KILLACTIVE        ; Page loosing focus

      m2m     lb1sel, index
      invoke  SetWindowLong, hdwnd, DWL_MSGRESULT, 0
      return  TRUE

    .ELSEIF eax==PSN_RESET             ; Add your own cancel code here

    .ENDIF

  .ELSEIF eax==WM_COMMAND

    LOWORD wParam
 
    .IF eax==IDD_ONE

      invoke  SendMessage, hPropSheet, PSM_SETCURSEL, 0, hPs   ; hPs[0], 4 & 8 are handles to pages 
      return  TRUE

    .ELSEIF eax==IDD_TWO

      invoke  SendMessage, hPropSheet, PSM_SETCURSEL, 1, hPs[4]
      return  TRUE

    .ELSEIF eax==IDD_THREE

      invoke  SendMessage, hPropSheet, PSM_SETCURSEL, 2, hPs[8]
      return  TRUE

    .ELSEIF eax==IDD_LB1               ; Process a list box LBN_DBLCLK

      invoke  SendMessage, hPropSheet, PSM_CHANGED, hdwnd, 0

;     See if user made a selection

      HIWORD  wParam
 
      .IF eax==LBN_DBLCLK            ; Process double click on list item

        invoke  SendDlgItemMessage, hdwnd, IDD_LB1, LB_GETCURSEL, 0, 0 ; Get index
        mov     ebx, eax
        shl     ebx,4        ; Allow for 15 bytes (+0) string length     
        invoke  wsprintf, ADDR strr, ADDR fmt, ADDR list[ebx]  
        invoke  MessageBox, hdwnd, ADDR strr, ADDR selmade, MB_OK      ; Displays selection

      .ENDIF

    .ENDIF

  .ELSEIF eax==WM_INITDIALOG       ; Initialise the list box

    xor     ebx,ebx

    .WHILE ebx < NUMSTRINGS*16

      invoke  SendDlgItemMessage, hdwnd, IDD_LB1, LB_ADDSTRING, 0, ADDR list[ebx]
      add     ebx, 16 

    .ENDW

;   Select 1st item

    invoke  SendDlgItemMessage, hdwnd, IDD_LB1, LB_SETCURSEL, lb1sel,0
    return  TRUE

  .ENDIF

  return  FALSE
;--------------------------------------
DialogFunc3 endp
