
.DATA

ErrorTitle      db  "Error:", 0
Error1          db  "Error accessing Windows Registry", 0

Registry1       db  "Software\Microsoft\Windows\CurrentVersion\Policies\System\", 0

Value           db  0
ValueDD         dd  0
TailValue       dd  4

NameValue       db  128 dup (0)
TailNameValue   dd  128

REG_TYPE        dd  0
REG_TYPEsz      db  "REG_DWORD", 0

.CODE

GetRegValue PROC rHKEY:DWORD, Registry:DWORD, NameValue1:DWORD, Typev:DWORD, BufferRec:DWORD, TailBufferRec:DWORD
;--------------------------------------
  LOCAL   Result  :DWORD
  LOCAL   hRegKey :DWORD

  invoke  RegCreateKeyEx, rHKEY, Registry, NULL, NULL, REG_OPTION_NON_VOLATILE, \
                          KEY_ALL_ACCESS, NULL, addr hRegKey, addr Result
  .IF eax == ERROR_SUCCESS

    invoke  RegQueryValueEx, hRegKey, NameValue1, NULL, Typev, BufferRec, TailBufferRec
    invoke  RegCloseKey, hRegKey

  .ELSE

    invoke  MessageBox, NULL, addr ErrorTitle, addr Error1, MB_OK + MB_ICONERROR

  .ENDIF

  xor     eax, eax
  mov     esi, dword ptr [BufferRec]
  mov     eax, dword ptr [esi]
  and     eax, 0000000Fh

  .IF eax > 1

    mov     eax, 0

  .ENDIF

  ret
;--------------------------------------
GetRegValue ENDP


SetRegValue PROC rHKEY:DWORD, Registry:DWORD, NameValue1:DWORD, Typev:DWORD, BufferRec:DWORD, TailBufferRec:DWORD
;--------------------------------------
  LOCAL   Result  :DWORD
  LOCAL   hRegKey :DWORD

  invoke  RegCreateKeyEx, rHKEY, Registry, NULL, addr REG_TYPEsz, REG_OPTION_NON_VOLATILE, \
                          KEY_ALL_ACCESS, NULL, addr hRegKey, addr Result

  .IF eax == ERROR_SUCCESS

    invoke  RegSetValueEx, hRegKey, NameValue1, NULL, Typev, BufferRec, TailBufferRec
    invoke  RegCloseKey, hRegKey

  .ELSE

    invoke  MessageBox, NULL, addr ErrorTitle, addr Error1, MB_OK + MB_ICONERROR

  .ENDIF

  ret
;--------------------------------------
SetRegValue ENDP
